const webpack = require('webpack')
const { merge } = require('webpack-merge')
const path = require('path')
const rootPath = process.cwd()
const gulpFunc = require('./gulpfile')

const { formatArgs } = require('./lib/utils')
const finalConfig = formatArgs(process.argv)
const {
  userFolder,
  buildFolder,
  currentEnv
} = finalConfig

const customWebpackPath = path.resolve(userFolder, 'llscw.csr.config.js')
const customWebpackConfig = require(customWebpackPath).csr({ userFolder, buildFolder, currentEnv })

const {
  webpackConfig,
  replace
} = customWebpackConfig

const finalWebpackConfig = merge(require("./webpack.common")({ ...finalConfig, replace }), {
  mode: "development",
  entry: ['./client/index.jsx'],
  output: {
    path: path.resolve(rootPath, "dist"),
    filename: "client.js",
    publicPath: '/', // 服务器脚本会用到
  },
  plugins: []
}, webpackConfig)

gulpFunc(() =>
  webpack(finalWebpackConfig,(err, stats)=>{})
)