const webpack = require('webpack')
const path = require('path')
const nodeExternals = require('webpack-node-externals');
const rootPath = process.cwd()
const gulpFunc = require('./gulpfile')

const { merge } = require('webpack-merge')

const { formatArgs } = require('./lib/utils')
const finalConfig = formatArgs(process.argv)
const {
  userFolder,
  buildFolder,
  currentEnv
} = finalConfig

const customWebpackPath = path.resolve(userFolder, 'llscw.ssr.config.js')
const customWebpackConfig = require(customWebpackPath).ssr({ userFolder, buildFolder, currentEnv })

const {
  webpackConfig,
  replace
} = customWebpackConfig

const finalWebpackConfig = merge(require("./webpack.common")({ ...finalConfig }), {
  mode: "development",
  entry: ['./server/index.jsx'],
  output: {
    path: path.resolve(rootPath, "dist"),
    filename: "server.js",
    publicPath: '/', // 服务器脚本会用到
    libraryTarget: 'commonjs2',
  },
  target: "node",
  externals: [nodeExternals()],
  module: {
    rules: [
    ],
  },
  plugins: [
  ]
}, webpackConfig)

// module.exports = webpackConfig
gulpFunc(() =>
  webpack(finalWebpackConfig,(err, stats)=>{})
)